import os
import json
from http.server import BaseHTTPRequestHandler, HTTPServer


KEEP_ALIVE = True
DOWNLOAD_URL = "http://ubuntuone.com/2X8m7WyX6G9gvKIyb1a3a6"


class MyHandler(BaseHTTPRequestHandler):

    def do_HEAD(self):
        self.send_response(200)
        self.send_header("X-Click-Token", "X-Click-Token")
        self.end_headers()

    def response_click_list(self):
        clicks = [
            {
                "framework": "ubuntu-sdk-13.10",
                "name": "com.ubuntu.dropping-letters",
                "title": "Dropping Letters game",
                "version": "0.1.3.2",
                "icon_url": "file:///usr/share/ubuntu/settings/system/icons/distributor-logo.png",
                "binary_filesize": 500000
            },
            {
                "framework": "ubuntu-sdk-13.10",
                "name": "com.ubuntu.stock-ticker-mobile",
                "title": "A stock trading app with charts, news, etc",
                "version": "0.3.7ubuntu1",
                "icon_url": "file:///usr/share/ubuntu/settings/system/icons/distributor-logo.png",
                "binary_filesize": 400000000
            },
            {
                "framework": "ubuntu-sdk-13.10",
                "name": "com.ubuntu.sudoku",
                "title": "Sudoku game for Ubuntu devices",
                "version": "0.5.2ubuntu2",
                "icon_url": "file:///usr/share/ubuntu/settings/system/icons/distributor-logo.png",
                "binary_filesize": 1800000000
            },
            {
                "framework": "ubuntu-sdk-13.10",
                "name": "com.ubuntu.developer.xda-app",
                "title": "XDA Developers App",
                "version": "0.4.2ubuntu2",
                "icon_url": "file:///usr/share/ubuntu/settings/system/icons/distributor-logo.png",
                "binary_filesize": 500000000
            }
        ]
        self.send_response(200)
        self.send_header("Content-type", "application/json")
        self.end_headers()
        self.wfile.write(bytes(json.dumps(clicks), 'UTF-8'))

    def response_url_package(self, packagename=''):
        response = {
            "name": packagename,
            "download_url": DOWNLOAD_URL
        }
        self.send_response(200)
        self.send_header("Content-type", "application/json")
        self.end_headers()
        self.wfile.write(bytes(json.dumps(response), 'UTF-8'))

    def do_POST(self):
        """Respond to a POST request."""
        #content = self.rfile.read(int(self.headers.get('content-length')))
        #structure = json.loads(content.decode('utf-8'))
        self.do_GET()

    def do_GET(self):
        """Respond to a GET request."""
        if self.path.find("myapps.developer") != -1:
            self.response_click_list()
        elif self.path.find("search.apps") != -1:
            packagename = os.path.basename(self.path)
            self.response_url_package(packagename=packagename)
        elif self.path.find("shutdown") != -1:
            global KEEP_ALIVE
            KEEP_ALIVE = False


def run_click_server(server_class=HTTPServer,
                   handler_class=BaseHTTPRequestHandler):
    server_address = ('', 8000)
    httpd = server_class(server_address, handler_class)
    global KEEP_ALIVE
    while KEEP_ALIVE:
        httpd.handle_request()


run_click_server(handler_class=MyHandler)